#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: fors2_menu.tcl,v 2.43 2004/06/17 23:04:32 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# hummel  13/08/99  created
# aaguayo 28/10/03  PPRS 10127 - Added 'Simple' Option
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#



#-----------------------------------------------
# add a menubutton with VLT-FORS items
# W. Hummel 20.nov.97
#-----------------------------------------------
proc add_fors2_menu {w} {
#-----------------------------------------------
   # fors1  
   set m [$w add_menubutton "FORS2"]

   # puts stdout "add_fors1_menu w=$w"
   # puts stdout "[$w component]"
   # puts stdout "[$w component image]"
   # puts stdout "[$w component image component]"
   # puts stdout "[lindex [$w component image info variable canvas_] 4]"
   # puts stdout "[lindex [$w component image info variable image_ ] 4]"

   # add the menus
   # index = 0
   $w add_menuitem $m cascade "Enter Mode" \
       {Create an Instrumental Mask on the canvas} \
       -state normal -menu [menu $m.create] 

   foreach i {IMG MOS MXU } {
        $w add_menuitem $m.create command "$i" \
            {Create a new mask} -state normal \
            -command [code f_on $w 1 [string tolower $i] $m]
            }

   # index = 1
   $w add_menuitem $m command "Reset Mode" \
    {Reset the current FORS1 mask } \
    -state disabled \
    -command { catch {::fors::FORS::my_mask reset_mask} } 

   # index =  2
   $w add_menuitem $m command "Load SetUp" \
    {Load Mask from TAF}  \
           -state disabled \
           -command { catch {::fors::FORS::my_mask load_TPX 0} }
   	
   # index = 3
   $w add_menuitem $m command "Quit Mode" \
    {Delete the current FORS mask } \
            -state disabled \
            -command [code f_off $w 1 all $m]

   # index = 4
   $m add separator

   # index = 5 
   $w add_menuitem $m cascade "Auto-Slit MOS/MXU" \
    {Compare target list with MOS slitlets}  \
           -state disabled \
           -menu [menu $m.autopos]

   # index = 6
   $w add_menuitem $m command "Save SetUp" \
   {Save the current FORS mask for OB processing} \
           -state disabled \
           -command [code f_con_sav $m] 
 
   # index = 7
   $w add_menuitem $m cascade "Reference Targets" \
   {Edit reference target list} \
           -state disabled \
           -menu [menu $m.reftarg] 

   # index = 8
   $w add_menuitem $m cascade "Status / Demo" \
      {Demo Test Info}  \
      -state disabled \
      -menu [menu $m.misc]

   # index = 9
   $m add separator

   # index = 10 
   $w add_menuitem $m cascade "Config / Layout" \
           {Graphical Layout of the FORS mask}  \
           -state disabled -menu [menu $m.layout -tearoff 1]
   	
   # in particular MOS and PMOS
   # --LAYOUT--
   #  0 = tearoff 
   #  1
   $w add_menuitem $m.layout cascade "Slit Width MOS/MXU/ECHS" \
            {Configure the slit width} \
            -state disabled -menu [menu $m.layout.sw]
   # 2
   $w add_menuitem $m.layout cascade "Slit Length MOS/MXU" \
            {Configure the slit length}  \
            -state disabled -menu [menu $m.layout.sl]
   # 3, in particular LSS
   $w add_menuitem $m.layout cascade "Slit Width LSS" \
            {Configure the slit width of the long slit}  \
            -state disabled -menu [menu $m.layout.ls]
   # 4, in particular HITS
   $w add_menuitem $m.layout cascade "Slit Width HITS" \
            {Configure the slit width of the hits slit}  \
            -state disabled -menu [menu $m.layout.ht]

   # 5, user-defined wavelength range for MOS/PMOS/LSS/HITS
   $w add_menuitem $m.layout command "WaveLength Range" \
          {Configure the wavelength range for spectroscopic mode}  \
          -state  disabled \
          -command { ::fors::FORS::my_mask wave_length  }

   # 6, in general (all modes except PMOS && highres )
   # 92/07/98 more complex : PMOS && highres && slit_width=open allowed
   # problem : co only known during run-time, m only known during init

   $w add_menuitem $m.layout cascade  "Collimator" \
      {Instrument SetUp: Collimator}  \
      -state normal -menu [menu $m.layout.sh] 

   # v0.9.6
   # 7 filters
   $w add_menuitem $m.layout cascade "OS Filter" \
           {Instrument SetUp : select OS Filter}  \
            -state disabled -menu [menu $m.layout.fi]
   
   # 8 grisms 
   $w add_menuitem $m.layout cascade "Grism" \
           {Instrument SetUp : select Grism}  \
            -state disabled -menu [menu $m.layout.gr]

   $m.layout add separator

   # 10, 9 = sperator        
   $w add_menuitem $m.layout cascade "Rotation Step" \
            {Configure the mask rotation speed}  \
            -state normal -menu [menu $m.layout.rs]
   # 11 
   $w add_menuitem $m.layout cascade "Color" \
            {Configure mask colour}  \
            -state normal -menu [menu $m.layout.cs]
   # 12
   $w add_menuitem $m.layout checkbutton "Transparency" \
            {Show positioned slit blades}  \
            -variable transp -onvalue 1 -offvalue 0 \
            -state disabled \
            -command { catch {::fors::FORS::my_mask configure -graytype $transp} }
   # 13
   $w add_menuitem $m.layout checkbutton "BadPixelMap" \
            {Plot the BadPixelMap} \
            -variable bpm    -onvalue 1 -offvalue 0 \
            -state normal \
            -command { catch {::fors::FORS::my_mask configure -badpixelmap $bpm } }

   # 14
   $w add_menuitem $m.layout checkbutton "Labels" \
            {Label the mask}  \
            -variable su -onvalue 1 -offvalue 0 \
            -state active \
            -command { catch {::fors::FORS::my_mask configure -label $su}
                } 
   # 15
   $w add_menuitem $m.layout checkbutton "Center Slit" \
            {Use PickObject to center MOS slit on target}  \
            -variable pisc -onvalue 1 -offvalue 0 \
            -state disabled \
            -command { catch {::fors::FORS::my_mask configure -pics $pisc} } 
                
   # 16
   $w add_menuitem $m.layout command "ProjectName" \
            {File name to be saved : <mode>.<ec>.<ProjectName>.fims }  \
          -state  disabled \
          -command { catch {::fors::FORS::my_mask select_filename } } 
                
   # 17
   $w add_menuitem $m.layout command "SetUpDir" \
            {Directory where to save <mode>.<ec>.<ProjectName>.fims }  \
          -state  disabled \
          -command { catch {::fors::FORS::my_mask select_set_dir } }
 

   # --SUB-LAYOUT--

   # --------------------index 0 = tearoff widget
   # --------------------index 1--MOS SLIT WIDTH
   #                     open means slitles spectroscopy
   foreach i {0.3 0.4 0.5 0.6 0.7 0.8 1.0 1.2 1.4 1.7 2.0 2.5 \
              3.0 3.5 4.0 5.0 10.0 22.0 30.0 45.0 60.0 open} {
     $w add_menuitem $m.layout.sw radio "  $i ''" \
         {Set Slit Width to $i}  \
         -variable sw -value $i \
         -command { catch {::fors::FORS::my_mask configure -slit_width $sw}
                  }
        }

   # --------------------index 2--MOS SLIT LENGTH
   foreach i {real 18.0 16.0 14.0 12.0 10.0 8.0 6.0 4.0 2.0 1.0 0.5 0.2} {
     $w add_menuitem $m.layout.sl radio "  $i ''" \
       {Set Slit Length to $i} \
       -variable sl -value $i  \
       -command {catch {::fors::FORS::my_mask configure -slit_length $sl}
                 }
       }

#                catch {::fors::FORS::my_mask adjust_slit_length}
#                catch {::fors::FORS::my_mask init_mask_world2}
#                catch {::fors::FORS::my_mask update_and_replot }


   # --------------------index 3--LSS SLIT WIDTH
   foreach i {all 0.3 0.4 0.5 0.7 1.0 1.3 1.6 2.0 2.5} {
     $w add_menuitem $m.layout.ls radio "  $i ''" \
         {Set Long Slit Width to $i}  \
         -variable ls -value $i \
         -command {catch {::fors::FORS::my_mask configure -long_width $ls}
                  }
          }

   # --------------------index 4--HITS SLIT WIDTH
   foreach i {all PH 0.5 0.7 1.0 1.3 1.6 2.0} {
     $w add_menuitem $m.layout.ht radio "  $i ''" \
         {Set Long Slit Width to $i}  \
         -variable ht -value $i \
         -command {catch {::fors::FORS::my_mask configure -long_width $ht}
                  }
         }
    # DEFAULT ht slit 8  with 2.0 arcsec


   # --------------------index 5--Wavelength Range 

   # --------------------index 6--Collimator  
   foreach i {none none} {
     $w add_menuitem $m.layout.sh radio "$i" \
         {Setup Instrument : Select Collimator}   \
         -variable co -value $i \
         -command { catch {::fors::FORS::my_mask configure \
                    -collimat $co } 
                  }
         }

   # v0.9.6 add grism filter menus
   # --------------------index 7--Filter
   # Filter
   set osfi_range {none none none none none none none none none none }

   foreach i $osfi_range {
     $w add_menuitem $m.layout.fi radio "$i" \
         {SetUp Instrument : Select OS Filter} \
         -variable fi -value $i  \
         -command { catch {::fors::FORS::my_mask configure -filter $fi }
                  }
        }

   # the next set of ten filters (10-20)
   # -----------------------------------
     $w add_menuitem $m.layout.fi cascade "more Filters (11-20)" \
        {Instrument SetUp : more Filters}  \
        -state normal -menu [menu $m.layout.fi.m2]

   foreach i $osfi_range {
     $w add_menuitem $m.layout.fi.m2 radio "$i" \
         {SetUp Instrument : Select OS Filter} \
         -variable fi -value $i  \
         -command { catch {::fors::FORS::my_mask configure -filter $fi }
                  }
        }

   # the next set of ten filters (20-30)
   # -----------------------------------
     $w add_menuitem $m.layout.fi cascade "more Filters (21-30)" \
        {Instrument SetUp : more Filters}  \
        -state normal -menu [menu $m.layout.fi.m3]

   foreach i $osfi_range {
     $w add_menuitem $m.layout.fi.m3 radio "$i" \
         {SetUp Instrument : Select OS Filter} \
         -variable fi -value $i  \
         -command { catch {::fors::FORS::my_mask configure -filter $fi }
                  }
         }

   # the next set of ten filters (30-40)
   # -----------------------------------
     $w add_menuitem $m.layout.fi cascade "more Filters (31-40)" \
        {Instrument SetUp : more Filters}  \
        -state normal -menu [menu $m.layout.fi.m4]

   foreach i $osfi_range {
     $w add_menuitem $m.layout.fi.m4 radio "$i" \
         {SetUp Instrument : Select OS Filter} \
         -variable fi -value $i  \
         -command { catch {::fors::FORS::my_mask configure -filter $fi }
                  }
         }

   # the next set of ten filters (40-50)
   # -----------------------------------
     $w add_menuitem $m.layout.fi cascade "more Filters (41-50)" \
        {Instrument SetUp : more Filters}  \
        -state normal -menu [menu $m.layout.fi.m5]

   foreach i $osfi_range {
     $w add_menuitem $m.layout.fi.m5 radio "$i" \
         {SetUp Instrument : Select OS Filter} \
         -variable fi -value $i  \
         -command { catch {::fors::FORS::my_mask configure -filter $fi }
                  }
        }


   # --------------------index 8--Grism   
   # Grism 
    set gris_range {none none none none none none none none none none none none none none none none none none none none}
    foreach i $gris_range {
      $w add_menuitem $m.layout.gr radio "$i" \
          {SetUp Instrument : Select Grism} \
          -variable gr -value $i  \
          -command { catch {::fors::FORS::my_mask configure -grism $gr }  
                   }
          }

  

   # --------------------index 9--Separator  


   # --------------------index 10--Rotator-Step
   # Rotation Step
   foreach i {0.05 0.1 0.3 1 2 5 10 15 45 90} {
     $w add_menuitem $m.layout.rs radio "  $i deg/click" \
         {Set Rotation Speed to $i} \
         -variable rs -value $i  \
         -command { catch {::fors::FORS::my_mask configure -rotangle $rs} 
                    catch {::fors::FORS::my_mask update_and_replot }
                  }
         }

   # --------------------index 11--Color
   foreach i {Red/Yellow  Green/Red Violet/Orange Black/White Gray \
              Bright Dark} {
     $w add_menuitem $m.layout.cs radio "  $i" \
         {Set color of mask to $i}  \
         -variable cs -value $i \
         -command {catch {::fors::FORS::my_mask configure -colorset $cs}
                   catch {::fors::FORS::my_mask update_and_replot}
                  }
         }

   # --------------------index 12--Graytype
   # we show the transparency in % but configure the graytype (e.g. gray50)
   # 100% transparency = look through (no stipple) graytype    (->  0)
   #   0% transparency = shutter closed, no background visible (->100)
   # foreach i {100 75 50 25 0} {
   #   $w add_menuitem $m.layout.st radio "  $i %" \
   #      {Set slitlet stipple graytype $i} \
   #       -variable st -value [expr 100-$i]  \
   #       -command { catch {::fors::FORS::my_mask configure -graytype $st}
   #                  catch {::fors::FORS::my_mask update_and_replot}
   #                }
   #       }

#  foreach i {0 1} {
#    $w add_menuitem $m.layout.st radio "$i" \
#       {Set slitlet stipple graytype $i} \
#        -variable st -value $i  \
#        -command { catch {::fors::FORS::my_mask configure -graytype $st}
#                   catch {::fors::FORS::my_mask update_and_replot}
#                 }
#        }

#  # --------------------index 13--MASK SCALE
#  foreach i { {Nominal} {FITS Header}  } {
#    $w add_menuitem $m.layout.ms radio "$i value" \
#       {set mask scale } \
#        -variable ms \
#        -value [string compare "Nominal" $i]  \
#        -command { catch {::fors::FORS::my_mask configure -fors_frame $ms}
#                   catch {::fors::FORS::my_mask update_and_replot}
#                 }
#        }

   # --------------------index 14--Labels
   
       #  drawback: if you change the default settings of 
       #  ::fors::FORS::my_mask then 
       # you should also adopt the corresponding invoke commands

     # -- AutoPos -- main menu index 4
     $w add_menuitem $m.autopos command "STATIC" \
         {AutoPosition; move slitlets, do not rotate or shift the mask} \
         -command { catch {::fors::FORS::my_mask AutoPos static} } \
         -state normal

     $w add_menuitem $m.autopos command "SHIFT" \
         {AutoPosition; move slitlets; shift the mask, do no rotate} \
         -command { catch {::fors::FORS::my_mask AutoPos shift} } \
         -state normal

     $w add_menuitem $m.autopos command "ROTAT" \
         {AutoPosition; move slitlets; rotate the mask, do not shift} \
         -command { catch {::fors::FORS::my_mask AutoPos rotat} } \
         -state normal

     $w add_menuitem $m.autopos command "ALL" \
         {AutoPosition; move slitlets; shift and rotate the mask} \
         -command { catch {::fors::FORS::my_mask AutoPos all} } \
         -state disabled

     # AAG - PPRS 10127
     # Added SIMPLE option

     $w add_menuitem $m.autopos command "SIMPLE" \
         {AutoPosition; move slitlets, do not rotate or shift the mask } \
         -command { catch {::fors::FORS::my_mask AutoPos simple} } \
         -state normal


     # MISC

     $w add_menuitem $m.misc command "Status" \
        {plot reference target list} \
        -command { catch {::fors::FORS::my_mask show_status} } \
        -state normal

     $w add_menuitem $m.misc command "Demo" \
        {brief demo} \
        -command { catch {::fors::FORS::my_mask demo} } \
        -state normal


         # -- RefTargs -- main menu index 7


     $w add_menuitem $m.reftarg command "plot" \
         {plot reference target list} \
         -command { catch {::fors::FORS::my_mask  edit_ref_targ plot} } \
         -state normal

     $w add_menuitem $m.reftarg command "show" \
         {show reference target list} \
         -command { catch {::fors::FORS::my_mask  edit_ref_targ show} } \
         -state normal

     $w add_menuitem $m.reftarg command "add" \
         {add reference targets to list} \
         -command { catch {::fors::FORS::my_mask edit_ref_targ add} } \
         -state normal

     $w add_menuitem $m.reftarg command "purge" \
         {purge individual reference targets from list} \
         -command { catch {::fors::FORS::my_mask edit_ref_targ purge} } \
         -state normal

     $w add_menuitem $m.reftarg command "verify" \
         {verify permitted positions of reference targets} \
         -command { catch {::fors::FORS::my_mask edit_ref_targ verify} } \
         -state normal

     $w add_menuitem $m.reftarg command "reset" \
         {purge all reference targets in list} \
         -command { catch {::fors::FORS::my_mask edit_ref_targ reset} } \
         -state normal

     $w add_menuitem $m.reftarg command "MOS10" \
         {switch the MOS-10 alignment option} \
         -command { catch {::fors::FORS::my_mask edit_ref_targ mtali} } \
         -state normal


}

#
# ___oOo___

